#include "mesh.hpp"

Mesh::Mesh()
{}

void Mesh::BuildQuadEdges() {
	vertices.clear();
	faces.clear();
	edges.clear();
}


void Mesh::ComputeVertexNormals() {

	N = Eigen::MatrixXd::Zero(V.rows(), 3);

}

void Mesh::ComputeVertexColors(
	const std::vector<std::vector<int> >& vertex_groups,
	Eigen::MatrixXd& C) {

	C = Eigen::MatrixXd::Zero(V.rows(), 3);

	for (int i = 0; i < vertex_groups.size(); ++i) {
		if (!vertex_groups[i].empty()) {
			const std::vector<int>& indices = vertex_groups[i];
			Eigen::Vector3d c(rand() / (double)RAND_MAX,
				rand() / (double)RAND_MAX,
				rand() / (double)RAND_MAX);
			for (auto& j : indices)
				C.row(j) = c;
		}
	}

}