#ifndef SUBDIVIDE_H_
#define SUBDIVIDE_H_

#include "mesh.hpp"

#include <Eigen/Core>

// Subdivide the mesh so that all edge lengths are smaller
// than a threshold. Maintain the vertices, faces, and quad
// edge structure.
// The input contains
//     mesh -> V   - An array of mesh vertices.
//     mesh -> F   - An array of mesh faces.
//     mesh -> edges, vertices, faces - Quad edge structure
//     len_thres - Edge length threshold.
// The output contains
//     mesh -> V, F and quad edge structure
void Subdivide(
	Mesh& mesh,
	double len_thres);

#endif