import os, sys

from pointnet_plusplus.architectures import build_pointnet2_seg
from pointnet_plusplus.utils import tf_util
from primitive import primitives

import tensorflow as tf
import numpy as np
from scipy.optimize import linear_sum_assignment

def get_per_point_model(scope, P, n_max_instances, is_training):
    ''' 
        Inputs:
            - P: BxNx3 tensor, the input point cloud
            - K := n_max_instances
        Outputs: a dict, containing
            - W: BxNxK, segmentation instances, fractional
            - normal_per_point: BxNx3, normal per point
            - type_per_point: BxNxT, type per points. NOTE: this is before taking softmax!
            - parameters - a dict, each entry is a BxKx... tensor
    '''

    ############################
    # TODO Task 2.2: Estimate membership matrix W, normal_per_point, type_per_point, and primitive parameters
    W = None
    normal_per_point = None
    type_per_point = None

    data_feed = {
        'P': P,
        'W': W,
        'normal_per_point': normal_per_point,
    }
    parameters = {}
    for primitive in primitives.get_all_primitives_classes():
        primitive.compute_parameters(data_feed, parameters)

    ############################
    
    return {
        'W': W,
        'normal_per_point': normal_per_point,
        'type_per_point': type_per_point,
        'parameters': parameters,
    }
