from .util import *
import tensorflow as tf
from math import pi as PI

class Cone:
    @staticmethod
    def get_primitive_name():
        return 'cone'

    @staticmethod
    def create_primitive_from_dict(d):
        assert d['type'] == 'cone'
        apex = np.array([d['apex_x'], d['apex_y'], d['apex_z']], dtype=float)
        axis = np.array([d['axis_x'], d['axis_y'], d['axis_z']], dtype=float)
        half_angle = float(d['semi_angle'])
        return Cone(apex=apex, axis=axis, half_angle=half_angle)

    @staticmethod
    def extract_parameter_data_as_dict(primitives, n_max_instances):
        return {
            'cone_axis_gt': np.zeros(dtype=float, shape=[n_max_instances, 3])
        }

    @staticmethod
    def insert_gt_placeholders(parameters_gt, n_max_instances):
        pass

    @staticmethod
    def fill_gt_placeholders(feed_dict, parameters_gt, batch):
        pass

    @staticmethod
    def compute_parameters(feed_dict, parameters):
        pass

    @staticmethod
    def compute_residue_loss(parameters, P_gt, matching_indices):
        pass

    @staticmethod
    def compute_parameter_loss(parameters_pred, parameters_gt, matching_indices, angle_diff):
        pass

    def __init__(self, apex, axis, half_angle, z_min=0.0, z_max=10.0):
        self.apex = apex
        self.axis = axis
        self.half_angle = half_angle
        self.z_min = z_min
        self.z_max = z_max
    