from .util import *
import tensorflow as tf

class Cylinder:
    @staticmethod
    def get_primitive_name():
        return 'cylinder'

    @staticmethod
    def create_primitive_from_dict(d):
        assert d['type'] == 'cylinder'
        location = np.array([d['location_x'], d['location_y'], d['location_z']], dtype=float)
        axis = np.array([d['axis_x'], d['axis_y'], d['axis_z']], dtype=float)
        radius = float(d['radius'])
        return Cylinder(center=location, radius=radius, axis=axis)

    @staticmethod
    def extract_parameter_data_as_dict(primitives, n_max_primitives):
        return {
            'cylinder_axis_gt': np.zeros(dtype=float, shape=[n_max_primitives, 3])
        }

    @staticmethod
    def insert_gt_placeholders(parameters_gt, n_max_instances):
        pass

    @staticmethod
    def fill_gt_placeholders(feed_dict, parameters_gt, batch):
        pass

    @staticmethod
    def compute_parameters(feed_dict, parameters):
        pass

    @staticmethod
    def compute_residue_loss(parameters, P_gt, matching_indices):
        pass

    @staticmethod
    def compute_parameter_loss(parameters_pred, parameters_gt, matching_indices, angle_diff):
        pass

    def __init__(self, center, radius, axis, height=10.0):
        self.center = center
        self.radius = radius
        self.axis = axis
        self.height = height

        tmp_axis = make_rand_unit_vector()
        self.x_axis = normalized(np.cross(tmp_axis, self.axis))
        self.y_axis = normalized(np.cross(self.axis, self.x_axis))

