from dataset import Dataset
import pickle
import numpy as np

import tensorflow as tf
def test_dataloader():
    train_data = Dataset(
        batch_size=2, 
        n_max_instances=24, 
        csv_path='../../../traceparts_data/train_models.csv', 
        noisy=True, 
        fixed_order=True, 
    )

    step = 0
    for batch in train_data.create_iterator():
        fp = open('../test/test_data.pkl','rb')
        batch_gt = pickle.load(fp)
        for k in batch_gt.keys():
            if not k in batch:
                print('1')
                return False
            if not batch_gt[k].shape == batch[k].shape:
                print('2')
                return False
            if not np.max(np.abs(batch_gt[k] - batch[k])) <= 1e-5:
                print('3')
                return False
        break

    return True

if __name__ == "__main__":
    if test_dataloader():
        print('Test success for data loader!')
    else:
        print('Test fail for data loader!')

