from evaluation import evaluate
import pickle
import numpy as np

import tensorflow as tf
def test_loss():
    fp = open('../test/test_loss.pkl','rb')
    pred_dict = pickle.load(fp)
    gt_dict = pickle.load(fp)
    eval_dict = pickle.load(fp)

    graph = tf.Graph()
    type_dict = {np.dtype('int32'):tf.int32, np.dtype('float32'):tf.float32}
    with graph.as_default():
        pred_dict_tensor = {}
        gt_dict_tensor = {}

        feed_dict = {}
        for k in pred_dict.keys():
            if (type(pred_dict[k]) == dict):
                pred_dict_tensor[k] = {}
                for c in pred_dict[k].keys():
                    pred_dict_tensor[k][c] = tf.placeholder(dtype=type_dict[pred_dict[k][c].dtype], shape=pred_dict[k][c].shape)
                    feed_dict[pred_dict_tensor[k][c]] = pred_dict[k][c]
            else:
                pred_dict_tensor[k] = tf.placeholder(dtype=type_dict[pred_dict[k].dtype], shape=pred_dict[k].shape)
                feed_dict[pred_dict_tensor[k]] = pred_dict[k]

        for k in gt_dict.keys():
            if (type(gt_dict[k]) == dict):
                gt_dict_tensor[k] = {}
                for c in gt_dict[k].keys():
                    gt_dict_tensor[k][c] = tf.placeholder(dtype=type_dict[gt_dict[k][c].dtype], shape=gt_dict[k][c].shape)
                    feed_dict[gt_dict_tensor[k][c]] = gt_dict[k][c]
            else:
                gt_dict_tensor[k] = tf.placeholder(dtype=type_dict[gt_dict[k].dtype], shape=gt_dict[k].shape)
                feed_dict[gt_dict_tensor[k]] = gt_dict[k]

        eval_dict_tensor = evaluate(pred_dict_tensor, gt_dict_tensor, is_eval=False)

        sess = tf.Session()
        eval_result = sess.run(eval_dict_tensor, feed_dict)

    for k in eval_dict.keys():
        if (type(eval_dict[k]) == dict):
            if not k in eval_result:
                print('key %s not found\n'%(k))
                continue
            for c in eval_dict[k].keys():
                if not c in eval_result[k]:
                    print('key %s.%s not found\n'%(k, c))
                    continue
                if eval_dict[k][c].shape != eval_result[k][c].shape:
                    print('key %s.%s has different shape\n'%(k,c))
                    continue
                if np.max(np.abs(eval_dict[k][c]-eval_result[k][c])) > 1e-6:
                    print('key %s.%s has data error\n'%(k,c))
                else:
                    print('test success for %s.%s\n'%(k,c))

    return True

if __name__ == "__main__":
    test_loss()
